### Test Scenario:

Benchmarking Notification Read API.

### Test Environment Details:
1. No of AKS node - 16
2. No of Notification service replicas - 8 (1Core and 1GB)
3. Cassandra Cluster- 7 Nodes (CPU- 16Core; Memory- 64GB)
4. Release version - Release 4.8.0


**API End Point:** `/api/notification/v1/feed/read/`


**Executing the test scenario using JMeter:**

```./run_scenario.sh <JMETER_HOME> <JMETER_IP_LIST> <SCENARIO_NAME> <SCENARIO_ID> <THREADS_COUNT> <RAMPUP_TIME> <CTRL_LOOPS> <API_KEY> <DOMAIN_FILE> <CSV_FILE> <pathPrefix>```

e.g.

```./run_scenario.sh ~/apache-jmeter-5.3/ '2Jmeter_Slave1_IP,Jmeter_Slave2_IP,Jmeter_Slave3_IP,Jmeter_Slave4_IP' notification-read notification-R1 5 1 5 ABCDEFabcdef012345 ~/testdata/host.csv ~/sunbird-perf-tests/testdata/userData.csv /api/notification/v1/feed/read ```

**Note:**

- Update `host.csv` file data with correct host details before running the test. It can be domain details / Kubernetes Node IPs/ LB IPs/ Direct Service IPs with port details.
- Update `userData.csv` file with valid user details (FirstName, userName, Email,	userId)


### Test Result 

| API           | Thread Count  | Samples  | Errors% | Throughput/sec|Avg Resp Time|   95th pct  |  99th pct   |
| ------------- | ------------- | -------- | --------| ---------------|------------|-------------|-------------|
| readNotificationFeed    | 200           | 2000000   | 0(0.00%)| 2214.8          |    89    | 121     | 174  |


### Server Utilisation:
| Backend          | CPU Usage %(max) | Memory Utilization (max)|
| ------------- | ------------- |------------- |
|Notification Service (CPU-1 Core; Memory- 1 GB)  |100% |392 MiB    |
|Cassandra (CPU- 16Core; Memory- 64GB)|  11.93%   |   13.773 GB |
